HDU 5024(枚举+搜索/记忆化搜索)

Wang Xifeng's Little Plot

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 751    Accepted Submission(s): 461


Problem Description
《Dream of the Red Chamber》(also 《The Story of the Stone》) is one of the Four Great Classical Novels of Chinese literature, and it is commonly regarded as the best one. This novel was created in Qing Dynasty, by Cao Xueqin. But the last 40 chapters of the original version is missing, and that part of current version was written by Gao E. There is a heart breaking story saying that after Cao Xueqin died, Cao's wife burned the last 40 chapter manuscript for heating because she was desperately poor. This story was proved a rumor a couple of days ago because someone found several pages of the original last 40 chapters written by Cao. 

In the novel, Wang Xifeng was in charge of Da Guan Yuan, where people of Jia family lived. It was mentioned in the newly recovered pages that Wang Xifeng used to arrange rooms for Jia Baoyu, Lin Daiyu, Xue Baochai and other teenagers. Because Jia Baoyu was the most important inheritor of Jia family, and Xue Baochai was beautiful and very capable , Wang Xifeng didn't want Jia Baoyu to marry Xue Baochai, in case that Xue Baochai might take her place. So, Wang Xifeng wanted Baoyu's room and Baochai's room to be located at two ends of a road, and this road should be as long as possible. But Baoyu was very bad at directions, and he demanded that there could be at most one turn along the road from his room to Baochai's room, and if there was a turn, that turn must be ninety degree. There is a map of Da Guan Yuan in the novel, and redists (In China English, one whose job is studying 《Dream of the Red Chamber》is call a "redist") are always arguing about the location of Baoyu's room and Baochai's room. Now you can solve this big problem and then become a great redist.
 

Input
The map of Da Guan Yuan is represented by a matrix of characters '.' and '#'. A '.' stands for a part of road, and a '#' stands for other things which one cannot step onto. When standing on a '.', one can go to adjacent '.'s through 8 directions: north, north-west, west, south-west, south, south-east,east and north-east.

There are several test cases.

For each case, the first line is an integer N(0<N<=100) ,meaning the map is a N × N matrix.

Then the N × N matrix follows.

The input ends with N = 0.
 

Output
For each test case, print the maximum length of the road which Wang Xifeng could find to locate Baoyu and Baochai's rooms. A road's length is the number of '.'s it includes. It's guaranteed that for any test case, the maximum length is at least 2.
 

Sample Input
3 #.# ##. ..# 3 ... ##. ..# 3 ... ### ..# 3 ... ##. ... 0
 

Sample Output
3 4 3 5
 

Source
 


题意:在一个n*n的矩阵中,‘.'表示可走。求最长通路(此通路最多有一个90度的拐角)。第一个案例:(0,1)->(1,2)->(2,1),长度最大为3。

分析:网络赛最水的一道当时我却没做出来==。。可以记忆化搜索,与《滑雪》这道题很像。当然后来看别人写的,发现只需要枚举拐角就行了==,这样比较好写,我怎么就没想到啊啊啊啊啊啊啊啊啊啊!!!!!!!!!!

code:

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>
#include<algorithm>
using namespace std;
typedef long long ll;
int n, maxn, dp[110][110][10][2]; //刚开始少了最后一维==
char s[110][110];
int d_x[] = {-1,-1,0,1,1,1,0,-1};
int d_y[] = {0,1,1,1,0,-1,-1,-1};

int dfs(int x, int y, int d, int t)
{
    if(dp[x][y][d][t]) return dp[x][y][d][t];
    for(int i=0; i<8; i++)
    {
        int xx = x+d_x[i], yy = y+d_y[i], temp = abs(i-d);
        if(xx < 0 || xx >= n || yy < 0 || yy >= n || s[xx][yy]=='#') continue;
        if(temp == 0)
        {
            dp[x][y][d][t] = max(dp[x][y][d][t],dfs(xx,yy,i,t)+1);
        }
        else if(temp == 2 || temp == 6)
        {
            if(t == 0) dp[x][y][d][t] = max(dp[x][y][d][t],dfs(xx,yy,i,t+1)+1);
        }
    }
    return dp[x][y][d][t];
}

int main()
{

    while(~scanf("%d", &n),n)
    {
        memset(dp, 0, sizeof(dp));
        for(int i=0; i<n; i++)
        {
            scanf("%s", s[i]);
        }
        maxn = 0;
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<n; j++)
            {
                if(s[i][j] == '#') continue;
                for(int d=0; d<8; d++)
                {
                    dp[i][j][d][0] = dfs(i,j,d,0);
                    maxn = max(maxn,dp[i][j][d][0]);
                    //printf("i=%d j=%d %d\n", i,j,maxn);
                }
            }
        }
        printf("%d\n", maxn+1);
    }
    return 0;
}
一般搜索的变量有几个,dp就会相应有几维。

发布了161 篇原创文章 · 获赞 45 · 访问量 16万+
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章